using System;
using System.Collections.Generic;
using System.Text;

namespace Exceptions
{
	class Program
	{
		class SpecializedException : Exception
		{
			public int Value = 0;

			public SpecializedException(string message, int v)
				: base(message)
			{
				Value = v;
			}
		}

		static void Main(string[] args)
		{
			try
			{
				ExceptionThrower(0);
				ExceptionThrower(1);
				ExceptionThrower(2);
			}
			catch (SpecializedException ex)
			{
				Console.WriteLine("Specialized exception thrown.");
				Console.WriteLine("Message: {0}", ex.Message);
				Console.WriteLine("Special value: {0}", ex.Value);
			}
			catch (Exception ex)
			{
				Console.WriteLine("Generic exception thrown.");
				Console.WriteLine("Message: {0}", ex.Message);
				throw;
			}
			finally
			{
				Console.WriteLine("Finally block executing.");
			}
			Console.ReadLine();
		}

		static void ExceptionThrower(int i)
		{
			switch (i)
			{
				case 0:
					return;

				case 1:
					throw new SpecializedException("Specialized message here", 21);

				case 2:
					throw new Exception("Generic exception message here.");
			}
		}

		static void OldWay()
		{
			bool something = true;

			if (something)
			{
				if (something)
				{
					if (something)
					{
						if (something)
						{
						}
						else
						{
							// handle error
						}
					}
					else
					{
						// handle error
					}
				}
				else
				{
					// handle error
				}
			}
			else
			{
				// handle error
			}
		}
	}
}
