using System;
using System.IO;
using System.Text;
using System.Collections.Generic;

namespace PlayList
{
	class MP3File
	{
		static int counter = 0;
		private string fullPath;

		public MP3File(string fullPath)
		{
			counter++;
			this.fullPath = fullPath;
		}

		public override string ToString()
		{
			return Path.GetFileName(fullPath);
		}

		public string FullPath
		{
			get
			{
				return fullPath;
			}
		}
	}

	class Program
	{
		static void Main(string[] args)
		{
			try
			{
				List<MP3File> fileList = new List<MP3File>();

				FileInfo fi = new FileInfo(args[0]);
				foreach (string f in Directory.GetFiles(fi.FullName, "*.mp3", SearchOption.AllDirectories))
				{
					fileList.Add(new MP3File(f));
				}
				fileList.Sort();
				foreach (MP3File f in fileList)
				{
					Console.WriteLine(f.FullPath);
				}
			}
			catch (Exception ex)
			{
				System.Console.Error.WriteLine("Exception: {0}", ex.Message);
			}
		}
	}
}
