using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Strings
{
	class RegexSamples
	{
		static public bool CheckEmailAddress(string address)
		{
			Regex EmailValidator = new Regex(@"^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$");
			return EmailValidator.IsMatch(address.Trim());
		}
	}

	class StringSamples
	{
		private string string1 = "This is a sample string. It is delimited by the usual white space.";

		public enum ShowEmptyStrings
		{
			Yes,
			No
		}

		private void PrintStringArray(string[] array, ShowEmptyStrings showEmpties)
		{
			foreach (string s in array)
			{
				if (showEmpties == ShowEmptyStrings.No)
				{
					if (s.Trim() == "") continue;
				}
				Console.WriteLine("Word: {0}", s);
			}
		}

		public void SplitDemo()
		{
			char[] delimiters = { ' ', '.' };

			PrintStringArray(string1.Split(delimiters), ShowEmptyStrings.Yes);
			Console.WriteLine("");
			PrintStringArray(string1.Split(delimiters), ShowEmptyStrings.No);
			Console.WriteLine("");
		}

		public void SubStringDemo()
		{
			Console.WriteLine("Indexed string: {0}", string1[0]);
			Console.WriteLine("10 character substring of string: {0}", string1.Substring(0, 10));
			Console.WriteLine("");
		}

		public void ReplaceDemo()
		{
			string s = string1;
			s = s.Replace("o", "0");
			s = s.Replace("e", "3");
			s = s.Replace("i", "1");
			Console.WriteLine("String after replacements: {0}", s);
			Console.WriteLine("");
		}

		public void StringBuilderDemo()
		{
			StringBuilder sb = new StringBuilder(string1);

			for (int i = 0; i < 100; i++)
			{
				sb.Append(" yeah ");
			}
			Console.WriteLine("String Builder result: {0}", sb.ToString());
			Console.WriteLine("");
		}

	}

	class Program
	{
		static void Main(string[] args)
		{
			StringSamples SS = new StringSamples();
			string[] testAddresses = {
				"23@foo.com",
				"a.@foo.com",
				"a-a@foo.com",
				"a_a@foo.com",
				" b@foo.c1m"
			};

			SS.SplitDemo();
			SS.SubStringDemo();
			SS.ReplaceDemo();
			SS.StringBuilderDemo();
			foreach (string e in testAddresses)
			{
				Console.WriteLine("Testing: {0} Is Valid: {1}", e, RegexSamples.CheckEmailAddress(e));
			}
			Console.ReadLine();
		}
	}
}
